/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.mappers.ObjectFlow;

import org.apache.log4j.Logger;
import org.visnow.vn.geometries.viewer3d.eventslisteners.render.FrameModificationEvent;
import org.visnow.vn.geometries.viewer3d.eventslisteners.render.FrameModificationListener;
import org.visnow.vn.geometries.viewer3d.eventslisteners.render.FrameRenderedListener;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.engine.core.Parameters;
import org.visnow.vn.geometries.viewer3d.eventslisteners.render.TimeRangeModificationEvent;
import org.visnow.vn.geometries.viewer3d.eventslisteners.render.TimeRangeModificationListener;
import static org.visnow.vn.lib.basic.mappers.ObjectFlow.ObjectFlowShared.*;

/**
 * ObjectFlowGUI class of time select/animate module (main module class is ObjectFlow)
 * <p>
 * @author Krzysztof S. Nowinski (know@icm.edu.pl), University of Warsaw ICM
 * @author Jędrzej M. Nowosielski (jnow@icm.edu.pl), University of Warsaw ICM
 */
public class ObjectFlowGUI extends javax.swing.JPanel
{

    private static final Logger LOGGER = Logger.getLogger(ObjectFlowGUI.class);
    private Parameters parameters;

    /**
     * Default constructor.
     * Creates new form GUI.
     */
    public ObjectFlowGUI()
    {
        initComponents();
        animationPanel.addListener(new FrameModificationListener()
        {
            public void frameChanged(FrameModificationEvent e)
            {
                parameters.set(NUMBER_OF_FRAMES, animationPanel.getLastFrame() + 1, ADJUSTING, animationPanel.isAdjusting(), TIME_FRAME, e.getTimeFrame());
            }
        });

        animationPanel.addTimeRangeModificationListener(new TimeRangeModificationListener()
        {

            @Override
            public void timeRangeChanged(TimeRangeModificationEvent e)
            {
                parameters.set(START_TIME, e.getTLow(), END_TIME, e.getTHigh());
            }
        });
    }

    /**
     * Empty constructor.
     * Used, when RegularFieldSliceGUI is extended to other alternative GUI class
     * (all of the Swing components are replaced - no initComponents() method should be called here - it should be called in subclass).
     * 
     * @param overrideComponents Doesn't matter if it's true or false - parameter is used only to differ signature from default constructor
     */
    public ObjectFlowGUI(boolean overrideComponents)
    {
    }
    
    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        animationPanel = new org.visnow.vn.lib.gui.AnimationPanel();
        jPanel1 = new javax.swing.JPanel();
        continuousUpdateBox = new javax.swing.JCheckBox();

        setPreferredSize(new java.awt.Dimension(220, 300));
        setLayout(new java.awt.GridBagLayout());

        animationPanel.setMaximumSize(new java.awt.Dimension(2147483647, 300));
        animationPanel.setMinimumSize(new java.awt.Dimension(170, 280));
        animationPanel.setPreferredSize(new java.awt.Dimension(220, 285));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        add(animationPanel, gridBagConstraints);

        jPanel1.setMinimumSize(new java.awt.Dimension(170, 20));
        jPanel1.setPreferredSize(new java.awt.Dimension(200, 120));
        jPanel1.setLayout(new java.awt.BorderLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.0;
        add(jPanel1, gridBagConstraints);

        continuousUpdateBox.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/visnow/vn/lib/basic/mappers/ObjectFlow/Bundle"); // NOI18N
        continuousUpdateBox.setText(bundle.getString("ObjectFlowGUI.continuousUpdateBox.text")); // NOI18N
        continuousUpdateBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                continuousUpdateBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(continuousUpdateBox, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void continuousUpdateBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_continuousUpdateBoxActionPerformed
    {//GEN-HEADEREND:event_continuousUpdateBoxActionPerformed
        animationPanel.setFrameSliderEnabled(!continuousUpdateBox.isSelected());
        parameters.set(CONTINUOUS_UPDATE, continuousUpdateBox.isSelected());
    }//GEN-LAST:event_continuousUpdateBoxActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private org.visnow.vn.lib.gui.AnimationPanel animationPanel;
    private javax.swing.JCheckBox continuousUpdateBox;
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables
    /**
     * Sets new value of parameters
     * <p>
     * @param parameters module parameters
     */
    public void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }

    /**
     * Updates ObjectFlowGUI to represent current status of field/params
     * <p>
     * @param p
     * @param resetGUIControls
     */
    public void updateGUI(ParameterProxy p, boolean resetGUIControls)
    {
        animationPanel.setNFrames(p.get(NUMBER_OF_FRAMES));
        animationPanel.setTimeRange(p.get(META_START_TIME), p.get(META_END_TIME), p.get(START_TIME), p.get(END_TIME));
        animationPanel.setTimeUnit(p.get(META_TIME_UNIT));        
        animationPanel.setFrame(p.get(TIME_FRAME), true); 

        continuousUpdateBox.setSelected(p.get(CONTINUOUS_UPDATE));

    }

    public FrameRenderedListener getFrameRenderedListener()
    {
        return animationPanel.getFrameRenderedListener();
    }

}
